<%
Option Explicit
%>
<!--#include file="config.asp"-->
<%
'******************************************************************************
'*  File: count.asp                                                           *
'*  Version: 0.2.0 Beta Launch                                                *
'*  Description: Called by an image (blank gif) to log hit to the website     *
'*               writes the hit details to database before redirecting to the *
'*               actual image file, if any                                    *
'*  Author: Andrew Pilgrim                                                    *
'*  Copyright: Copyright 2002 Andrew Pilgrim, andrewpilgrim@fswebdesign.com   *
'*  Licence: Free for personal and commercial use as long as copyright notice *
'*           remains in place. Distribution prohibited without the express    *
'*           permission of the owner (andrewpilgrim@fswebdesign.com)          *
'*           full licence at http://www.fswebdesign.com/fsstats/              *
'******************************************************************************

'-----------------------------------------------------------------------------
'                               Version History
'-----------------------------------------------------------------------------
'	9 June 2002: Version 0.1.0a
'   14 June 2002: Version 0.2.0 Beta Launch

'Please report all bugs to fsstats@fswebdesign.com or go to:
'     http://www.fswebdesign.com/fsstats/

Dim DataConn

Function GetBrowserID(Browser_Name, Raw_Browser_Version)
  '##Returns the ID of the browser if it already exists otherwise it adds the browser then returns ID
  Dim SQL_Query
  Dim BrowserRS
  Dim Browser_Version
  Dim Start_Position

  '##Initialise start position
  Start_Position = 1

  '##Change raw browser version information into actual browser version
  If Browser_Name = "Microsoft Internet Explorer" Then
    '##Account for MSIE using Mozilla compatable version number
	'##Navigate to first number
    While Asc(Mid(Raw_Browser_Version, Start_Position, 1)) > 57 Or Asc(Mid(Raw_Browser_Version, Start_Position, 1)) < 48
	  '##Increment position marker
	  Start_Position = Start_Position + 1
    Wend
    
	'##Go to end of numbers
	While (Asc(Mid(Raw_Browser_Version, Start_Position, 1)) < 58 And Asc(Mid(Raw_Browser_Version, Start_Position, 1)) > 47) Or Asc(Mid(Raw_Browser_Version, Start_Position, 1)) = 46
	  '##Increment position marker
      Start_Position = Start_Position + 1
    Wend
  End If

  '##Find version number
  '##Navigate to first number
  While Asc(Mid(Raw_Browser_Version, Start_Position, 1)) > 57 Or Asc(Mid(Raw_Browser_Version, Start_Position, 1)) < 48
	'##Increment position marker
	Start_Position = Start_Position + 1
  Wend
    
  '##Go to end of numbers, whilst building version string
  While (Asc(Mid(Raw_Browser_Version, Start_Position, 1)) < 58 And Asc(Mid(Raw_Browser_Version, Start_Position, 1)) > 47) Or Asc(Mid(Raw_Browser_Version, Start_Position, 1)) = 46
	Browser_Version = Browser_Version & Mid(Raw_Browser_Version, Start_Position, 1)
	'##Increment position marker
    Start_Position = Start_Position + 1
  Wend

  '##Define query
  SQL_Query = "SELECT * FROM tbl_Browser WHERE Name = '" & Browser_Name & "' AND Version = '" & Browser_Version & "'"

  '##Create recordset object
  Set BrowserRS = Server.CreateObject("ADODB.RecordSet")

  '##Run query
  BrowserRS.Open SQL_Query,DataConn,1,3

  '##Check if any records were returned
  If BrowserRS.EOF And BrowserRS.BOF Then
    '##No records exist so add new browser record
	'##Add new record, not the quickest method but allows for instant retreval of ID 
	BrowserRS.AddNew
    
	'##Plug in the values to be added
	BrowserRS("Name") = Browser_Name
	BrowserRS("Version") = Browser_Version

    '##Insert the record
	BrowserRS.Update
  End If

  '##Get the value of the ID
  GetBrowserID = BrowserRS("Browser_ID")

  '##Close Connections
  BrowserRS.Close
  Set BrowserRS = Nothing  
End Function 

Function GetOSID (OS_Name)
  '##Returns the ID of the operating system if it exists, otherwise adds the OS and returns ID
  Dim SQL_Query
  Dim OSRS

  '##Lower case the OS_Name
  OS_Name = LCase(OS_Name)

  '##Big is statement to get correct OS string! No other way of doing it?
  If InStr(1, OS_Name, "windows 95") <> 0 Or InStr(1, OS_Name, "win95") <> 0 Or InStr(1, OS_Name, "win 95") <> 0 Then
    OS_Name = "Windows 95"
  ElseIf InStr(1, OS_Name, "windows 98") <> 0 Or InStr(1, OS_Name, "win98") <> 0 Or InStr(1, OS_Name, "win 98") <> 0 Then
    OS_Name = "Windows 98"
  ElseIf InStr(1, OS_Name, "windows me") <> 0 Or InStr(1, OS_Name, "winme") <> 0 Or InStr(1, OS_Name, "win me") <> 0 Then
    OS_Name = "Windows ME"
  ElseIf InStr(1, OS_Name, "windows 2000") <> 0 Or InStr(1, OS_Name, "win2k") <> 0 Or InStr(1, OS_Name, "win 2k") <> 0 Or InStr(1, OS_Name, "win 2000") <> 0 Then
    OS_Name = "Windows 2K"
  ElseIf InStr(1, OS_Name, "windows nt") <> 0 Or InStr(1, OS_Name, "winnt") <> 0 Or InStr(1, OS_Name, "win nt") <> 0 Then
    OS_Name = "Windows NT"
  ElseIf InStr(1, OS_Name, "windows xp") <> 0 Or InStr(1, OS_Name, "winxp") <> 0 Or InStr(1, OS_Name, "win xp") <> 0 Then
    OS_Name = "Windows XP"
  ElseIf InStr(1, OS_Name, "mac") <> 0 Then
    OS_Name = "Mac"
  ElseIf InStr(1, OS_Name, "freebsd") <> 0 Then
    OS_Name = "FreeBSD"
  ElseIf InStr(1, OS_Name, "sun") <> 0 Then
    OS_Name = "SunOS"
  ElseIf InStr(1, OS_Name, "irix") <> 0 Then
    OS_Name = "IRIX"
  ElseIf InStr(1, OS_Name, "be") <> 0 Then
    OS_Name = "BEOS"
  ElseIf InStr(1, OS_Name, "os") <> 0 Then
    OS_Name = "OS/2"
  ElseIf InStr(1, OS_Name, "aix") <> 0 Then
    OS_Name = "AIX"
  Else
    '##have no clue
	OS_Name = "(Unknown)"
  End If    

  '##Define SQL Query
  SQL_Query = "SELECT * FROM tbl_Operating_Systems WHERE OS_Name = '" & OS_Name & "'"

  '##Create recordset
  Set OSRS = Server.CreateObject("ADODB.RecordSet")

  '##Run Query
  OSRS.Open SQL_Query,DataConn,1,3

  '##Check to see if OS exists
  If OSRS.EOF And OSRS.BOF Then
    '##OS doesn't exost so add it
	OSRS.AddNew

	'##Plug in the value
	OSRS("OS_Name") = OS_Name

	'##Add record
	OSRS.Update
  End If

  '##Return ID
  GetOSID = OSRS("Operating_System_ID")

  '##Close Connections
  OSRS.Close
  Set OSRS = Nothing
End Function

Function GetColorDepthID (Color_Depth)
  '##Returns the ID of the color depth if it exists, otherwise adds the depth and returns ID
  Dim SQL_Query
  Dim ColorDepthRS

  '##Sort it out if the values passed are bad
  If LCase(Color_Depth) = "undefined" Or LCase(Color_Depth) = "" Then Color_Depth = "Unknown"

  '##Define SQL Query
  SQL_Query = "SELECT * FROM tbl_Color_Depths WHERE Name = '" & Color_Depth & "'"

  '##Create recordset
  Set ColorDepthRS = Server.CreateObject("ADODB.RecordSet")

  '##Run Query
  ColorDepthRS.Open SQL_Query,DataConn,1,3

  '##Check to see if color depth exists
  If ColorDepthRS.EOF And ColorDepthRS.BOF Then
    '##color depth doesn't exist so add it
	ColorDepthRS.AddNew

	'##Plug in the value
	ColorDepthRS("Name") = Color_Depth

	'##Add record
	ColorDepthRS.Update
  End If

  '##Return ID
  GetColorDepthID = ColorDepthRS("Color_Depth_ID")

  '##Close Connections
  ColorDepthRS.Close
  Set ColorDepthRS = Nothing
End Function

Function GetRefererID (Referer)
  '##Returns the ID of the Referer if it exists, otherwise adds the Referer and returns ID
  Dim SQL_Query
  Dim RefererRS

  '##Set direct Hit if no referer
  If Referer = "" Then Referer = "(Direct Hit)"

  '##Define SQL Query
  SQL_Query = "SELECT * FROM tbl_Referers WHERE URL = '" & Referer & "'"

  '##Create recordset
  Set RefererRS = Server.CreateObject("ADODB.RecordSet")

  '##Run Query
  RefererRS.Open SQL_Query,DataConn,1,3

  '##Check to see if Referer exists
  If RefererRS.EOF And RefererRS.BOF Then
    '##Referer doesn't exist so add it
	RefererRS.AddNew

	'##Plug in the value
	RefererRS("URL") = Referer

	'##Add record
	RefererRS.Update
  End If

  '##Return ID
  GetRefererID = RefererRS("Referer_ID")

  '##Close Connections
  RefererRS.Close
  Set RefererRS = Nothing
End Function

Function GetResolutionID (Resolution)
  '##Returns the ID of the Resolution if it exists, otherwise adds the Resolution and returns ID
  Dim SQL_Query
  Dim ResolutionRS

  '##Sort it out if the values passed are bad
  If LCase(Resolution) = "undefined" Or LCase(Resolution) = "" Then Resolution = "Unknown"

  '##Define SQL Query
  SQL_Query = "SELECT * FROM tbl_Resolutions WHERE Name = '" & Resolution & "'"

  '##Create recordset
  Set ResolutionRS = Server.CreateObject("ADODB.RecordSet")

  '##Run Query
  ResolutionRS.Open SQL_Query,DataConn,1,3

  '##Check to see if Resolution exists
  If ResolutionRS.EOF And ResolutionRS.BOF Then
    '##Resolution doesn't exist so add it
	ResolutionRS.AddNew

	'##Plug in the value
	ResolutionRS("Name") = Resolution

	'##Add record
	ResolutionRS.Update
  End If

  '##Return ID
  GetResolutionID = ResolutionRS("Resolution_ID")

  '##Close Connections
  ResolutionRS.Close
  Set ResolutionRS = Nothing
End Function


Function GetHitID(IP_Addr, Session_ID)
  '##Checks to see if the user has been logged as a hit already in this session, if they have not 
  '##then their details are added to a new record. It returns the hits ID number to be used in the 
  '##page views table.
  Dim SQL_Query
  Dim HitsRS

  '##Define SQL Query, this works on the basis that a hit counts as a unqiue IP address and session 
  '##ID combination. There is a possibility of a mistaken hit counted as a pageview but this is very 
  '##very unlikely. May be corrected in later versions.
  SQL_Query = "SELECT * FROM tbl_Hits WHERE IP_Addr = '" & IP_Addr & "' And Session_ID = '" & Session_ID & "'"

  '##Create recordset
  Set HitsRS = Server.CreateObject("ADODB.RecordSet")

  '##Run Query
  HitsRS.Open SQL_Query,DataConn,1,3

  '##Check to see if HIT already exists
  If HitsRS.EOF And HitsRS.BOF Then
    '##Hit has yet to be logged so log it!
	HitsRS.AddNew

	'##Plug in values from the server variables
	HitsRS("IP_Addr") = IP_Addr
	HitsRS("Session_ID") = Session_ID
	HitsRS("Client") = GetBrowserID(Request.QueryString("client"),Request.QueryString("version"))
	HitsRS("Color_Depth") = GetColorDepthID(Request.QueryString("color_depth"))
	HitsRS("Resolution") = GetResolutionID(Request.QueryString("width") & "*" & Request.QueryString("height"))
    HitsRS("Operating_System") = GetOSID(Request.QueryString("version"))
	HitsRS("Referer") = GetRefererID(Request.QueryString("referrer"))

	'##Add record
	HitsRS.Update
  End If

  '##Return Hit ID
  GetHitID = HitsRS("Hit_ID")

  '##Close Connections
  HitsRS.Close
  Set HitsRS = Nothing
End Function

'---------------------------------------------------------------------
'##Main Page

'##Open global database connection
Set DataConn = Server.CreateObject("ADODB.Connection")
DataConn.Open Conn_String

'##Log the page view
DataConn.Execute "INSERT INTO tbl_Page_Views(Hit_ID,Date_Time,Page) values(" & GetHitID(Request.ServerVariables("REMOTE_ADDR"),Session.SessionID) & ",#" & Now & "#,'" & Request.QueryString("url") & "')"

'##Close Connections
DataConn.Close
Set DataConn = Nothing

'##Show the image
Response.Redirect Image_URL
%>